"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports._retries = exports._streams = exports.main = void 0;

var _net = _interopRequireDefault(require("net"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// exponential backoff, roughly 100ms-6s
const retries = [1, 2, 3, 4, 5].map(num => Math.exp(num) * 40);
exports._retries = retries;
const streams = {
  stdout: process.stdout // overwritable by tests

};
exports._streams = streams;

const communicate =
/*#__PURE__*/
function () {
  var _communicate = _asyncToGenerator(function* (socketPath, message) {
    yield new Promise((resolve, reject) => {
      const client = _net.default.connect(socketPath, () => {
        client.end(message);
        client.pipe(streams.stdout);
      });

      client.on('error', err => reject(err));
      client.on('close', err => {
        if (err) {
          reject(err);
        } else {
          resolve();
        }
      });
    });
  });

  function communicate(_x, _x2) {
    return _communicate.apply(this, arguments);
  }

  return communicate;
}();

const main =
/*#__PURE__*/
function () {
  var _main = _asyncToGenerator(function* (...args) {
    try {
      yield communicate(...args);
    } catch (err) {
      const recoverable = err.code === 'ECONNREFUSED' || err.code === 'ENOENT';

      if (recoverable && retries.length) {
        yield new Promise((resolve, reject) => {
          setTimeout(() => {
            main(...args).then(resolve, reject);
          }, retries.shift());
        });
      }
    }
  });

  function main() {
    return _main.apply(this, arguments);
  }

  return main;
}();
/* istanbul ignore if */


exports.main = main;

if (require.main === module) {
  _asyncToGenerator(function* () {
    try {
      yield main(...process.argv.slice(2));
    } catch (err) {
      process.stderr.write(`${err.stack}\n`);
      process.exit(1);
    }
  })();
}
//# sourceMappingURL=postcss-client.js.map